enchant();

// マップサイズ
MAP_SIZE_WIDTH = 64;
MAP_SIZE_HEIGHT = 64;

MAP_LAYER = parseInt(Math.random()*50);//レイヤー数
MAP_DETAIL = parseInt(Math.random()*128);//細かさ
MAP_PILE = Math.random()/10;//重なり率
        
//マップタイル定義　0～256の範囲をマップタイルに割り当てる

//for 16x16 px
var mt = [
    //海
    {range:[  0, 110],  map0:[0],
                        around:
                        [16,17,18,
                        32,0,34,
                        48,49,50,
                        8,24,40,56,72,88,
                        2],
                        collision:[1]},
    //平原
    {range:[111, 129],  map0:[1],
                        around:
                        [1,1,1,
                        1,1,1,
                        1,1,1,
                        1,1,1,1,1,1,
                        1],
                        collision:[0]},
    //森
    {range:[130, 256],  map0:[131],
                        around:
                        [147,148,149,
                        163,164,165,
                        179,180,181,
                        134,150,166,182,131,131,
                        131],
                        collision:[0]}
];

window.onload = function() {
    core = new Core(320, 320);
    core.fps = 15;

    // 使用する画像ファイルを読み込む
    core.preload('map1.png', 'chara5.png', 'chara6.png', 'piece.png', 'start.png', 'end.png', 'button.png', 'clear.png');

    core.onload = function() {

        // マップを作成する
        map = new Field(MAP_SIZE_WIDTH, MAP_SIZE_HEIGHT, MAP_LAYER, MAP_DETAIL, MAP_PILE);

        // 「stage」グループを作成する 
        stage = new Group();
        // 「stage」グループにマップを追加する
        stage.addChild(map);
        // rootSceneに「stage」グループを追加する
        core.rootScene.addChild(stage);
        
        core.rootScene.on('touchmove',function(e){
            stage.x=stage.startx+e.x-stage.ex;
            stage.y=stage.starty+e.y-stage.ey;
        });
        core.rootScene.on('touchstart',function(e){
            stage.startx=stage.x;
            stage.starty=stage.y;
            stage.ex=e.x;
            stage.ey=e.y;
        });
    };
    core.start();
};

var Field = Class.create(Map, {
    createMap: function(destW, destH, layerNo, srcDtl, pileRate) {
        var resArr = [];
        var nMax = layerNo;
        var pile = (nMax * pileRate) | 0;

        if (srcDtl * 2 > destW) srcDtl = (destW / 2) | 0;
        if (srcDtl * 2 > destH) srcDtl = (destH / 2) | 0;

        var srcWU = (destW / srcDtl - 1) | 0;
        var srcHU = (destH / srcDtl - 1) | 0;
        for (var n = 0; n < nMax; n++) {
            // 元の画素
            var srcW = srcWU * (n + 1);
            var srcH = srcHU * (n + 1);
            var srcSz = srcW * srcH;
            var srcArr = [];
            for (var i = 0; i < srcSz; i++) {
                srcArr[i] = xors.rand() % 2 * 255;
                //srcArr[i]=parseInt(Math.random()*256);
            }

            // バイリニア補間用
            var scaleX = destW / (srcW - 1);
            var scaleY = destH / (srcH - 1);

            // 重ね比率
            var plRes = (n + pile) / (n + pile + 1);
            var plDest = 1 / (n + pile + 1);

            // バイリニア補間法
            for (var y = 0; y < destH; y++) {
                // Y系変数の初期化
                var ySrc0 = (y / scaleY) | 0;
                var ySrcW0 = ySrc0 * srcW;
                var ySrcW1 = (ySrc0 + 1) * srcW;
                var yDst0 = y / scaleY - ySrc0;
                var yDst1 = 1 - yDst0;
                var yP = y * destW;

                for (var x = 0; x < destW; x++) {
                    // X系変数の初期化
                    var xSrc0 = (x / scaleX) | 0;
                    var xSrc1 = xSrc0 + 1;
                    var xDst0 = x / scaleX - xSrc0;
                    var xDst1 = 1 - xDst0;

                    // 周囲4隅の画素
                    var col0 = srcArr[xSrc0 + ySrcW0];
                    var col1 = srcArr[xSrc1 + ySrcW0];
                    var col2 = srcArr[xSrc0 + ySrcW1];
                    var col3 = srcArr[xSrc1 + ySrcW1];

                    // 画素の合成
                    var col = (
                    xDst1 * yDst1 * col0 + xDst0 * yDst1 * col1 + xDst1 * yDst0 * col2 + xDst0 * yDst0 * col3) | 0;

                    // マップの合成
                    var p = x + yP;
                    if (n == 0) {
                        resArr[p] = col;
                    } else {
                        resArr[p] = (resArr[p] * plRes + col * plDest) | 0;
                    }
                }
            }
        }

        mapArray = [];
        collision=[];
        for (i=0;i<destH;i++){
            line=[];
            colline=[];
            for (j=0;j<destW;j++){
                maptile = this.getMapTile(resArr[i*destH+j], mt);
                line.push(maptile);
                colline.push(maptile.collision);
            }
            mapArray.push(line);
            collision.push(colline);
        }
        mapT=[];
        for (i=0;i<destH;i++){
            for (j=0;j<destW;j++){
                celltop=0;
                cellbottom = 0;//non
                if (i>0){
                    if (mapArray[i-1][j] != mapArray[i][j]){
                        celltop = 1;//top
                    }
                }
                if (i<mapArray.length-1){
                    if (mapArray[i+1][j] != mapArray[i][j]){
                        cellbottom = 1;//bottom
                    }
                }
                cellleft=0;
                cellright = 0;//non
                if (j>0){
                    if (mapArray[i][j-1] != mapArray[i][j]){
                        cellleft=1;//left
                    }
                }
                if (j<mapArray[i].length-1){
                    if ((mapArray[i][j+1] != mapArray[i][j])){
                        cellright=1;//right
                    }
                }
                
                
                if (typeof(mapT[i]) == "undefined"){
                    mapT[i]=[];
                }
                chip=''+celltop+cellbottom+cellleft+cellright;
                switch(chip){
                    case '0000':
                        cell = 4;//normal
                    break;
                    case '0001':
                        cell = 5;//right
                    break;
                    case '0010':
                        cell = 3;//left
                    break;
                    case '0011':
                        cell = 13;//left-right
                    break;
                    case '0100':
                        cell = 7;//bottom
                    break;
                    case '0101':
                        cell = 8;//bottom-right
                    break;
                    case '0110':
                        cell = 6;//bottom-lfet
                    break;
                    case '0111':
                        cell = 9;//bottom-left-right
                    break;
                    case '1000':
                        cell = 1;//top
                    break;
                    case '1001':
                        cell = 2;//top-right
                    break;
                    case '1010':
                        cell = 0;//top-left
                    break;
                    case '1011':
                        cell = 10;//top-left-right
                    break;
                    case '1100':
                        cell = 14;//top-bottom
                    break;
                    case '1101':
                        cell = 12;//top-bottom-right
                    break;
                    case '1110':
                        cell = 11;//top-bottom-left
                    break;
                    case '1111':
                        cell = 15;//all
                    break;
                }
                
                mapT[i][j]=[];
                mapT[i][j] = mapArray[i][j][cell];
            }
        }

        // 戻り値
        return [mapT, collision];
    },
    initialize: function(width, height, layer, detail, pile) {
        Map.call(this, 16, 16);
        this.image = core.assets['map1.png'];
        
        field = this.createMap(width, height, layer, detail, pile);
        this.loadData(field[0]);
        this.collisionData = field[1];
    },
    // Map TIleの取得
    getMapTile: function(col,mt) {
        var mtLen = mt.length;
        for (var i = 0; i < mtLen; i ++) {
            if (mt[i].range[0] <= col && col < mt[i].range[1]) {
                return mt[i].around;
            }
        }

        return mt[0].around;
    }

}); //Field end

// Xorshift
var xors = new function() {
    // シード
    this.seed = function(s) {
        // 初期化
        x = 123456789;
        y = 362436069;
        z = 521288629;
        w = s;
    }
    this.seed(88675123);    // 初回実行

    // ランダム
    this.rand = function() {
        var t;
        t = x ^ (x << 11);
        x = y;
        y = z;
        z = w;
        return w = (w^(w>>19))^(t^(t>>8));
    }
};
